diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 329f6a6f6..c64ed88a3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -94,17 +95,22 @@ public class ExplosionCannonball extends Explosion{
             double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double)explosionSize;
             if(d4 <= 1.0D)
             {
-                double d6 = entity.x - explosionX;
-                double d8 = entity.y - explosionY;
-                double d10 = entity.z - explosionZ;
-                double d11 = MathHelper.sqrt(d6 * d6 + d8 * d8 + d10 * d10);
-                d6 *= 2.5;
-                d8 /= d11;
-                d10 *= 2.5;
+                double xComp = entity.x - explosionX;
+                double yComp = entity.y - explosionY;
+                double zComp = entity.z - explosionZ;
+                double d11 = MathHelper.sqrt(xComp * xComp + yComp * yComp + zComp * zComp);
+                xComp *= 2.5;
+                yComp /= d11;
+                yComp += 0.5f;
+                zComp *= 2.5;
                 double d12 = worldObj.getSeenPercent(vec3, entity.bb);
-                double d13 = (1.0D - d4) * d12;
-                entity.hurt(exploder, (int)(((d13 * d13 + d13) / 2D) * 8D * (double)explosionSize + 1.0D), DamageType.BLAST);
-                entity.fling(d6 * d13, (d8 * d13) + 0.5F, d10 * d13, 1);
+                double flingForce = (1.0D - d4) * d12;
+                entity.hurt(exploder, (int)(((flingForce * flingForce + flingForce) / 2D) * 8D * (double)explosionSize + 1.0D), DamageType.BLAST);
+                if (entity instanceof IArmorWearing && entity != exploder) {
+                    float proc = 1 - (((IArmorWearing<?>) entity).getTotalProtectionAmount(DamageType.BLAST) / 2f);
+                    flingForce *= proc;
+                }
+                entity.fling(xComp * flingForce, yComp * flingForce, zComp * flingForce, 1);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index aa187ae6f..7dfac1349 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.SpawnListEntry;
@@ -32,12 +33,12 @@ import java.util.Set;
 public final class SpawnerMobs
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private static final Set<ChunkCoordinate> eligibleChunksForSpawning = new HashSet<>();
-    private static final Class<?>[] nightSpawnEntities;
+    private static final Set<ChunkCoordinate> ELIGIBLE_CHUNKS_FOR_SPAWNING = new HashSet<>();
+    private static final Class<? extends Mob>[] NIGHT_SPAWN_ENTITIES;
 
     static
     {
-        nightSpawnEntities = new Class[] {
+        NIGHT_SPAWN_ENTITIES = new Class[] {
             MobSpider.class, MobZombie.class, MobSkeleton.class, MobZombieArmored.class
         };
     }
@@ -57,7 +58,7 @@ public final class SpawnerMobs
     public static int performSpawning(World world, SpawnerConfig spawnerConfig)
     {
         if(!spawnerConfig.canHostileSpawn(world) && !spawnerConfig.canPassiveSpawn(world)) { return 0; }
-        eligibleChunksForSpawning.clear();
+        ELIGIBLE_CHUNKS_FOR_SPAWNING.clear();
 
         for (Player player : world.players){
             final int playerChunkX = MathHelper.floor(player.x / (double) Chunk.CHUNK_SIZE_X);
@@ -67,7 +68,7 @@ public final class SpawnerMobs
             for(int dx = -spawnRadius; dx <= spawnRadius; ++dx) {
                 for(int dz = -spawnRadius; dz <= spawnRadius; ++dz) {
                     if(world.isChunkLoaded(dx + playerChunkX, dz + playerChunkZ)) {
-                        eligibleChunksForSpawning.add(new ChunkCoordinate(dx + playerChunkX, dz + playerChunkZ));
+                        ELIGIBLE_CHUNKS_FOR_SPAWNING.add(new ChunkCoordinate(dx + playerChunkX, dz + playerChunkZ));
                     }
                 }
             }
@@ -87,10 +88,10 @@ public final class SpawnerMobs
 
             if (creatureType.isPeaceful() && !spawnerConfig.canPassiveSpawn(world)) continue;
             if (!creatureType.isPeaceful() && !spawnerConfig.canHostileSpawn(world)) continue;
-            if (world.countEntities(creatureType.getBaseClass()) > ((creatureType.getMaxCreaturesPerChunk() * eligibleChunksForSpawning.size()) / 256))
+            if (world.countEntities(creatureType.getBaseClass()) > ((creatureType.getMaxCreaturesPerChunk() * ELIGIBLE_CHUNKS_FOR_SPAWNING.size()) / 256))
                 continue;
 
-            chunkLoop: for (ChunkCoordinate chunk : eligibleChunksForSpawning) {
+            chunkLoop: for (ChunkCoordinate chunk : ELIGIBLE_CHUNKS_FOR_SPAWNING) {
                 boolean checkSpawnDist = false;
                 for (ChunkCoordinate c : spawnChunks){
                     if (c.equals(chunk)){
@@ -127,7 +128,8 @@ public final class SpawnerMobs
                     }
                 }
 
-                if (!spawnerConfig.canMobSpawn(EntityDispatcher.idForClass(spawnListEntry.entityClass))) continue;
+                EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(spawnListEntry.entityClass);
+                if (entry == null || !spawnerConfig.canMobSpawn(entry.namespaceID)) continue;
 
                 final ChunkPosition pos = getRandomSpawningPointInChunk(world, chunk.x, chunk.z);
                 final int x = pos.x;
@@ -166,7 +168,7 @@ public final class SpawnerMobs
 
                         Mob mobToSpawn;
                         try {
-                            mobToSpawn = (Mob) spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
+                            mobToSpawn = (Mob) EntityDispatcher.getInstance().createEntityInWorld(spawnListEntry.entityClass, world);
                         } catch (Exception e) {
                             LOGGER.error("Error spawning entity class '{}' class missing default constructor for World! Skipping spawn attempt!", spawnListEntry.entityClass.getSimpleName(), e);
                             return totalSpawned;
@@ -213,7 +215,7 @@ public final class SpawnerMobs
             return false;
         }
 
-        Class<?>[] entityClasses = nightSpawnEntities;
+        Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
         if (entityClasses != null && entityClasses.length != 0) {
             boolean willSpawnEntity = false;
             PathFinder pathFinder = new PathFinder(world);
@@ -249,9 +251,9 @@ public final class SpawnerMobs
                     float entityZ = z + 0.5f;
 
                     Mob entity;
-                    Class<?> eClass = entityClasses[world.rand.nextInt(entityClasses.length)];
+                    Class<? extends Mob> eClass = entityClasses[world.rand.nextInt(entityClasses.length)];
                     try {
-                        entity = (Mob) eClass.getConstructor(World.class).newInstance(world);
+                        entity = EntityDispatcher.getInstance().createEntityInWorld(eClass, world);
                     } catch (Exception e) {
                         LOGGER.error("Exception instancing class '{}'!", eClass.getSimpleName(), e);
                         return false;
@@ -301,7 +303,7 @@ public final class SpawnerMobs
                 continue;
             }
 
-			Class<?>[] entityClasses = nightSpawnEntities;
+			Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
 			if (entityClasses != null && entityClasses.length != 0)
             {
 				boolean spawnedEntityForPlayer = false;
@@ -340,10 +342,10 @@ public final class SpawnerMobs
 						float entityZ = z + 0.5f;
 
 						Mob entity;
-                        Class<?> eClass= entityClasses[world.rand.nextInt(entityClasses.length)];
+                        Class<? extends Mob> eClass= entityClasses[world.rand.nextInt(entityClasses.length)];
 						try
                         {
-							entity = (Mob) eClass.getConstructor(World.class).newInstance(world);
+							entity = EntityDispatcher.getInstance().createEntityInWorld(eClass, world);
 						}
                         catch (Exception e)
                         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 83f15db1f..6e39f17b4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -12,9 +12,7 @@ import java.util.TreeSet;
 import java.util.UUID;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.tags.CompoundTag;
 
-import net.minecraft.core.block.BlockLogicOreRedstone;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.EntityItem;
@@ -61,6 +59,7 @@ import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.PlayerIO;
 import net.minecraft.core.world.saveddata.SavedData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
@@ -193,10 +192,6 @@ public class World implements WorldSource {
             levelData = new LevelData(seed, name);
             isNewWorld = true;
         }
-        else
-        {
-            levelData.setWorldName(name);
-        }
 
         if (dimensionData == null)
         {
@@ -215,7 +210,7 @@ public class World implements WorldSource {
 
         chunkProvider = createChunkProvider();
 
-        auroraProvider = new AuroraProvider(this, seed);
+        auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
 
         seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
@@ -293,7 +288,7 @@ public class World implements WorldSource {
 
         this.weatherManager = new WeatherManager(this);
 
-        auroraProvider = new AuroraProvider(this, seed);
+        auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
 
         biomeProvider = this.worldType.createBiomeProvider(this);
 
@@ -362,15 +357,15 @@ public class World implements WorldSource {
         return getBlockId(x, y, z);
     }
 
-    public void spawnPlayerWithLoadedChunks(Player player)
+    public void spawnPlayerWithLoadedChunks(Player player, boolean respawning)
     {
         try
         {
-            CompoundTag nbttagcompound = levelData.getPlayerNBTTagCompound();
-            if(nbttagcompound != null)
-            {
-                player.load(nbttagcompound);
-                levelData.setPlayerNBTTagCompound(null);
+            if (!respawning) {
+                PlayerIO playerIO = saveHandler.getPlayerFileData();
+                if (playerIO != null) {
+                    playerIO.load(player);
+                }
             }
             int chunkX = MathHelper.floor_float((int)player.x) / Chunk.CHUNK_SIZE_X;
             int chunkZ = MathHelper.floor_float((int)player.z) / Chunk.CHUNK_SIZE_Z;
@@ -2132,11 +2127,6 @@ public class World implements WorldSource {
         }
     }
 
-    public Entity findSubclassOf(Class<? extends Entity> clazz) // this is what the b1.2 mappings called this
-    {
-        return null;
-    }
-
     public @Nullable Entity getEntityByID(int id)
     {
         for(int i = 0; i < loadedEntityList.size(); i++)
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 0450575ff..4b0154c8b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -286,7 +286,7 @@ public class ChunkLoaderLegacy
                 if (entityTagBase instanceof CompoundTag)
                 {
                     CompoundTag entityTag = (CompoundTag) entityTagBase;
-                    Entity entity = EntityDispatcher.createEntityFromNBT(entityTag, world);
+                    Entity entity = EntityDispatcher.getInstance().createEntityFromNBT(entityTag, world);
                     chunk.hasEntities = true;
                     if (entity != null)
                     {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 7195f0743..8ccca75ff 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -131,10 +131,29 @@ public class ChunkDecoratorOverworld
             int j5 = x + rand.nextInt(16) + 8;
             int k8 = minY + rand.nextInt(rangeY);
             int j11 = z + rand.nextInt(16) + 8;
-            if (rand.nextInt(2) == 0) {
+
+            int design = rand.nextInt(2);
+            if (design == 1) {
+                int id = world.getBlockId(j5, k8, j11);
+                if (id == Blocks.LIMESTONE.id()) {
+                    design = 2;
+                } else if (id == Blocks.GRANITE.id()) {
+                    design = 3;
+                } else if (id == Blocks.BASALT.id()) {
+                    design = 4;
+                }
+            }
+
+            if (design == 0) {
                 new WorldFeatureDungeon(Blocks.BRICK_CLAY.id(), Blocks.BRICK_CLAY.id(), null).place(world, rand, j5, k8, j11);
-            } else {
+            } else if (design == 1) {
                 new WorldFeatureDungeon(Blocks.COBBLE_STONE.id(), Blocks.COBBLE_STONE_MOSSY.id(), null).place(world, rand, j5, k8, j11);
+            } else if (design == 2) {
+                new WorldFeatureDungeon(Blocks.COBBLE_LIMESTONE.id(), Blocks.COBBLE_LIMESTONE_MOSSY.id(), null).place(world, rand, j5, k8, j11);
+            } else if (design == 3) {
+                new WorldFeatureDungeon(Blocks.COBBLE_GRANITE.id(), Blocks.COBBLE_GRANITE_MOSSY.id(), null).place(world, rand, j5, k8, j11);
+            } else if (design == 4) {
+                new WorldFeatureDungeon(Blocks.COBBLE_BASALT.id(), Blocks.COBBLE_BASALT_MOSSY.id(), null).place(world, rand, j5, k8, j11);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index f652ee87d..c02f98658 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -61,7 +61,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
             brickBlockB = Blocks.BRICK_SANDSTONE.id();
             slabBlock = Blocks.SLAB_SANDSTONE.id();
         }
-        if (biome == Biomes.OVERWORLD_TAIGA || biome == Biomes.OVERWORLD_TUNDRA || biome == Biomes.OVERWORLD_GLACIER)
+        else if (biome == Biomes.OVERWORLD_TAIGA || biome == Biomes.OVERWORLD_TUNDRA || biome == Biomes.OVERWORLD_GLACIER)
         {
             wallBlockA = Blocks.PERMAFROST.id();
             wallBlockB = Blocks.COBBLE_PERMAFROST.id();
@@ -69,6 +69,40 @@ public class WorldFeatureLabyrinth extends WorldFeature
             brickBlockB = Blocks.BRICK_PERMAFROST.id();
             isCold = true;
         }
+        else
+        {
+            int design = 0;
+            final int id = world.getBlockId(x, y - 5, z);
+            if (id == Blocks.LIMESTONE.id()) {
+                design = 1;
+            } else if (id == Blocks.GRANITE.id()) {
+                design = 2;
+            } else if (id == Blocks.BASALT.id()) {
+                design = 3;
+            }
+
+            if (design == 1) // Limestone
+            {
+                wallBlockA = Blocks.COBBLE_LIMESTONE.id();
+                wallBlockB = Blocks.COBBLE_LIMESTONE_MOSSY.id();
+                brickBlockA = brickBlockB = Blocks.BRICK_LIMESTONE.id();
+                slabBlock = Blocks.SLAB_LIMESTONE_POLISHED.id();
+            }
+            else if (design == 2) // Granite
+            {
+                wallBlockA = Blocks.COBBLE_GRANITE.id();
+                wallBlockB = Blocks.COBBLE_GRANITE_MOSSY.id();
+                brickBlockA = brickBlockB = Blocks.BRICK_GRANITE.id();
+                slabBlock = Blocks.SLAB_GRANITE_POLISHED.id();
+            }
+            else if (design == 3) // Basalt
+            {
+                wallBlockA = Blocks.COBBLE_BASALT.id();
+                wallBlockB = Blocks.COBBLE_BASALT_MOSSY.id();
+                brickBlockA = brickBlockB = Blocks.BRICK_BASALT.id();
+                slabBlock = Blocks.SLAB_BASALT_POLISHED.id();
+            }
+        }
 
         this.chestLoot = new WeightedRandomBag<>();
         chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 1, 6), 100);
@@ -509,7 +543,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                                 if (x == blockX || z == blockZ) {
                                     world.setBlockWithNotify(x, y, z, isCold ? Blocks.OBSIDIAN.id() : Blocks.FLUID_LAVA_FLOWING.id());
                                 } else {
-                                    world.setBlockWithNotify(x, y, z, isCold ? Blocks.PERMAFROST_POLISHED.id() : Blocks.STONE_POLISHED.id());
+                                    world.setBlockWithNotify(x, y, z, slabBlock);
                                 }
                             else if (random.nextInt(5) == 0)
                                 world.setBlockWithNotify(x, y, z, wallBlockB);
@@ -543,9 +577,9 @@ public class WorldFeatureLabyrinth extends WorldFeature
         for (int x = blockX - 1; x <= blockX + 1; x++) {
             for (int z = blockZ - 1; z <= blockZ + 1; z++) {
                 if (x == blockX && z == blockZ) {
-                    world.setBlockAndMetadataWithNotify(x, blockY - 1, z, isCold ? Blocks.SLAB_PERMAFROST_POLISHED.id() : Blocks.SLAB_STONE_POLISHED.id(), 1);
+                    world.setBlockAndMetadataWithNotify(x, blockY - 1, z, slabBlock, 1);
                 } else {
-                    world.setBlockWithNotify(x, blockY - 1, z, isCold ? Blocks.SLAB_PERMAFROST_POLISHED.id() : Blocks.SLAB_STONE_POLISHED.id());
+                    world.setBlockWithNotify(x, blockY - 1, z, slabBlock);
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
index b1e00bbfd..73b7bca1d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -3,17 +3,17 @@ package net.minecraft.core.world.save;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
-import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.File;
 import java.io.IOException;
 import java.nio.file.Files;
-import java.util.List;
+import java.util.UUID;
 
 public class LevelData
 {
@@ -25,9 +25,13 @@ public class LevelData
     private long worldTime;
     private long lastTimePlayed;
     private long sizeOnDisk;
+    @Deprecated
     private CompoundTag playerTag;
+    @Deprecated
     private int dimension;
+    @Deprecated
     private int gamemode;
+    private @Nullable UUID lastPlayerUUID;
     private @NotNull String levelName = "DEFAULT NAME";
     private int saveVersion;
     private boolean cheatsEnabled;
@@ -78,6 +82,7 @@ public class LevelData
         spawnerConfig = levelData.getSpawnerConfig();
         difficulty = levelData.difficulty;
         difficultyLocked = levelData.difficultyLocked;
+        lastPlayerUUID = levelData.lastPlayerUUID;
     }
 
     public LevelData(File worldDir)
@@ -126,30 +131,12 @@ public class LevelData
 
     public CompoundTag getNBTTagCompound()
     {
-        CompoundTag nbttagcompound = new CompoundTag();
-        updateTagCompound(nbttagcompound, playerTag);
-        return nbttagcompound;
+        CompoundTag tag = new CompoundTag();
+        updateTagCompound(tag);
+        return tag;
     }
 
-    public CompoundTag getNBTTagCompoundWithPlayer(List<Player> list)
-    {
-        CompoundTag nbttagcompound = new CompoundTag();
-        Player entityplayer = null;
-        CompoundTag nbttagcompound1 = null;
-        if(!list.isEmpty())
-        {
-            entityplayer = list.get(0);
-        }
-        if(entityplayer != null)
-        {
-            nbttagcompound1 = new CompoundTag();
-            entityplayer.saveWithoutId(nbttagcompound1);
-        }
-        updateTagCompound(nbttagcompound, nbttagcompound1);
-        return nbttagcompound;
-    }
-
-    private void updateTagCompound(CompoundTag levelTag, CompoundTag playerTag)
+    private void updateTagCompound(CompoundTag levelTag)
     {
         levelTag.putLong("RandomSeed", randomSeed);
         levelTag.putInt("SpawnX", spawnX);
@@ -163,15 +150,15 @@ public class LevelData
         levelTag.putBoolean("CheatsEnabled", cheatsEnabled);
         levelTag.putInt("Difficulty", difficulty.id());
         levelTag.putBoolean("DifficultyLock", difficultyLocked);
-        if(playerTag != null)
-        {
-            levelTag.putCompound("Player", playerTag);
-        }
 
         CompoundTag gameRulesTag = new CompoundTag();
         GameRuleCollection.writeToNBT(gameRulesTag, gameRules);
         levelTag.put("GameRules", gameRulesTag);
 
+        if (lastPlayerUUID != null) {
+            levelTag.putString("LastPlayerUUID", lastPlayerUUID.toString());
+        }
+
         if (spawnerConfig != null) {
             CompoundTag spawnerConfigTag = new CompoundTag();
             spawnerConfig.writeToTag(spawnerConfigTag);
@@ -208,6 +195,9 @@ public class LevelData
         {
             gameRules = new GameRuleCollection();
         }
+        if (tag.containsKey("LastPlayerUUID")) {
+            lastPlayerUUID = UUID.fromString(tag.getString("LastPlayerUUID"));
+        }
 
         if (tag.containsKey("SpawnConfig")) {
             CompoundTag spawnConfigTag = tag.getCompound("SpawnConfig");
@@ -247,16 +237,22 @@ public class LevelData
         return sizeOnDisk;
     }
 
+    @Deprecated
     public CompoundTag getPlayerNBTTagCompound()
     {
         return playerTag;
     }
 
+    @Deprecated
     public int getDimension()
     {
         return dimension;
     }
 
+    public @Nullable UUID getLastPlayerUUID() {
+        return lastPlayerUUID;
+    }
+
     public void setSpawnX(int x)
     {
         spawnX = x;
@@ -282,9 +278,14 @@ public class LevelData
         sizeOnDisk = size;
     }
 
-    public void setPlayerNBTTagCompound(CompoundTag nbttagcompound)
+    @Deprecated
+    public void setPlayerNBTTagCompound(CompoundTag tag)
     {
-        playerTag = nbttagcompound;
+        playerTag = tag;
+    }
+
+    public void setLastPlayerUUID(@Nullable UUID lastPlayerUUID) {
+        this.lastPlayerUUID = lastPlayerUUID;
     }
 
     public void setSpawn(int x, int y, int z)
@@ -319,11 +320,13 @@ public class LevelData
         return lastTimePlayed;
     }
 
+    @Deprecated
     public int getGamemode()
     {
     	return gamemode;
     }
 
+    @Deprecated
     public void setGamemode(int gamemode)
     {
     	this.gamemode = gamemode;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
index f09593fce..a74037d40 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
@@ -1,13 +1,17 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 import java.io.File;
 import java.util.List;
+import java.util.UUID;
 
-public interface LevelStorage
+public interface LevelStorage extends PlayerIO
 {
 	/**
 	 * Loads the level data for this save.
@@ -35,10 +39,11 @@ public interface LevelStorage
 
 	/**
 	 * Saves the level data and data for any players.
+
 	 * @param levelData The level data to save.
 	 * @param playerList A list of players whose data should be saved.
 	 */
-	void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList);
+	void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList);
 
 	/**
 	 * Saves the level data.
@@ -80,7 +85,11 @@ public interface LevelStorage
 	 */
 	void saveDimensionDataRaw(int dimensionId, CompoundTag dimensionDataTag);
 
-	PlayerIO getPlayerFileData();
+	@Nullable PlayerIO getPlayerFileData();
+
+	@Nullable CompoundTag getPlayerData(@Nullable String username, @NotNull UUID uuid);
 
 	File getDataFile(String fileName);
+
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/PlayerIO.java b/game/core/src/main/java/net/minecraft/core/world/save/PlayerIO.java
index 64496b8ce..296490a3c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/PlayerIO.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/PlayerIO.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.world.save;
 
 import net.minecraft.core.entity.player.Player;
+import org.jetbrains.annotations.NotNull;
 
 public interface PlayerIO
 {
 
-    void save(Player player);
+    void save(@NotNull Player player);
+
+    void load(@NotNull Player player);
 
-    void load(Player player);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
index 55deba72b..3e23aa206 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
@@ -4,7 +4,6 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Map;
 import java.util.Objects;
 
 public class SaveFile
@@ -24,12 +23,12 @@ public class SaveFile
         this.corrupted = levelData == null || (!needsConversion && dimensionData.get(0) == null);
     }
 
-    public String getFileName()
+    public @NotNull String getFileName()
     {
         return fileName;
     }
 
-    public String getDisplayName()
+    public @NotNull String getDisplayName()
     {
         return displayName;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index 0e29802b1..d479aba76 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -8,14 +8,13 @@ import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.File;
 import java.nio.file.Files;
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 
 public abstract class SaveFormatBase
     implements ISaveFormat
@@ -23,6 +22,8 @@ public abstract class SaveFormatBase
     private static final Logger LOGGER = LogUtils.getLogger();
     protected final File savesDir;
 
+    public @NotNull SaveHandlerBase.SaveHandlerFactory factory = SaveHandlerCore::new;
+
     public SaveFormatBase(File savesDir)
     {
         if(!savesDir.exists())
@@ -219,7 +220,7 @@ public abstract class SaveFormatBase
     @Override
     public LevelStorage getSaveHandler(String worldDirName, boolean isMultiplayer)
     {
-        return new SaveHandlerCore(this, savesDir, worldDirName, isMultiplayer);
+        return factory.apply(this, savesDir, worldDirName);
     }
 
     protected static void deleteFilesRecursively(File[] dirFiles)
